
static char rcsid[] = 
	"$Id: commands.c,v 2.310 1994/07/18 18:18:05 kohl Exp $";

#include "xpvm.h"

extern int gstid;

/* ARGSUSED */
int hosts_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	HOST H;

	HOST last;

	char result[1024];
	char msg[1024];
	char tmp[1024];

	char *refname;

	int hindex;
	int found;
	int hid;

	if ( argc < 2 )
	{
		Tcl_SetResult( itp,
			"usage: pvm_hosts [ <button_index> | -1 <other_host> ]",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	hid = atoi( argv[1] );

	switch ( hid )
	{
		case ADD_ALL_HID:
		{
			add_all_hosts();

			break;
		}

		default:
		{
			/* Add Other Host */

			if ( hid < 0 )
			{
				/* Extract Regular Host Name */

				refname = copy_str( argv[2] );

				sscanf( refname, "%s", tmp );
				
				/* Look for Host in Host List (D-Oh!) */

				H = HOST_LIST;

				last = (HOST) NULL;

				found = 0;

				while ( H != NULL && !found )
				{
					if ( !strcmp( tmp, H->name )
						|| !strcmp( tmp, H->alias ) )
					{
						found++;
					}

					else
					{
						last = H;

						H = H->next;
					}
				}

				/* Host already present, add normally... */

				if ( found )
				{
					if ( H->in_pvm == NOT_IN_PVM )
					{
						if ( H->refname != NULL )
							free( H->refname );

						H->refname = refname;

						do_add_host( H );
					}

					else
					{
						sprintf( msg,
						   "setMsg { Error: Host %s Already Present! }",
						   tmp );
						
						Tcl_Eval( itp, msg );

						free( refname );
					}
				}

				/* Add Host to Host List */

				else
				{
					last->next = create_host();
	
					H = last->next;
	
					H->refname = refname;
	
					H->name = copy_str( tmp );
	
					H->alias = host_alias_str( H->name );
	
					H->index = NHOSTS;
	
					sprintf( result,
						"checkHostResult { {NEW %s %d PERM} {ON %d} }",
						host_name( H, FALSE ), MAX_HID + NHOSTS,
						H->index );
	
					Tcl_Eval( interp, result );
	
					NHOSTS++;
	
					/* Add Host to PVM */
	
					H->in_pvm = NOT_IN_PVM;
	
					do_add_host( H );
				}
			}

			/* Add Specific Host */

			else
			{
				hindex = hid - MAX_HID;

				H = get_host_index( hindex );

				if ( H != NULL )
				{
					if ( H->in_pvm == IN_PVM )
						do_delete_host( H );

					else if ( H->in_pvm == NOT_IN_PVM )
						do_add_host( H );
				}
			}
		}
	}

	return( TCL_OK );
}

/* ARGSUSED */
int tasks_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	struct pvmtaskinfo *T;
	struct pvmtaskinfo *tip;

	char result[4096];
	char msg[4096];
	char tmp[1024];
	char trc[255];

	char *strcat();

	char **av;
	int ac;

	char *where;
	char *args;
	char *name;
	char *init;

	int *tids;

	int ntasks;
	int signal;
	int ntask;
	int stval;
	int flag;
	int tid;
	int cc;
	int i;

	if ( !strcmp( argv[1], "spawn" ) )
	{
		init = copy_str( argv[2] );

		name = copy_str( argv[3] );

		args = copy_str( argv[4] );

		ntasks = atoi( argv[5] );

		/* Extract Args */

		Tcl_SplitList( interp, args, &ac, &av );

		/* Check Spawn Command Line Args */

		strcpy( tmp, "" );

		where = (char *) NULL;

		flag = 0;

		for ( i=6 ; i < argc ; i++ )
		{
			if ( !strcmp( argv[i], "debug" ) )
				flag |= PvmTaskDebug;

			else if ( !strcmp( argv[i], "trace" ) )
				flag |= PvmTaskTrace;

			else if ( !strcmp( argv[i], "front" ) )
				flag |= PvmMppFront;

			else if ( !strcmp( argv[i], "compl" ) )
				flag |= PvmHostCompl;

			else if ( !strcmp( argv[i], "host" ) )
			{
				flag |= PvmTaskHost;

				where = copy_str( argv[i+1] );

				sprintf( tmp, " on %s", where );

				i++;
			}

			else if ( !strcmp( argv[i], "arch" ) )
			{
				flag |= PvmTaskArch;

				where = copy_str( argv[i+1] );

				sprintf( tmp, " on %s", where );

				i++;
			}
		}

		sprintf( msg, "setMsg \"Spawning %d cop%s of %s%s...\"",
			ntasks, ( ntasks > 1 ? "ies" : "y" ), name, tmp );

		Tcl_Eval( interp, msg );

		/* Set Up Trace Stuff for Auto Play */

		if ( !TRACE_DO_SPAWN
			&& ( !strcmp( init, "fresh" )
				|| ( !strcmp( init, "append" )
					&& ( TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK
						|| TRACE_OUT == NULL ) ) ) )
		{
			if ( do_reset_views( itp ) == TCL_ERROR )
				return( TCL_ERROR );

			TRACE_FILE_STATUS = TRACE_FILE_OVERWRITE;

			PROCESS_COUNTER_INTERVAL = PROCESS_COUNTER_OVERWRITE;
			RECV_TIMER_INTERVAL = RECV_TIMER_OVERWRITE;

			strcpy( trc, "global trace_file_status; " );
				
			strcat( trc, "set trace_file_status \"OverWrite\"" );

			if ( Tcl_Eval( interp, trc ) == TCL_ERROR )
				return( TCL_ERROR );

			TRACE_DO_SPAWN = TRUE;

			if ( !setup_trace( itp ) )
				return( TCL_OK );
		}

		TRACE_DO_SPAWN = FALSE;

		/* Spawn Task(s) */

		tids = (int *) malloc( (unsigned) ntasks * sizeof(int) );
		memcheck( tids, "Spawn Return TIDs Array" );

		if ( !( flag & PvmTaskTrace ) )
			pvm_setopt( PvmTraceTid, 0 );

		cc = pvm_spawn( name, av, flag, where, ntasks, tids );

		if ( !( flag & PvmTaskTrace ) )
			pvm_setopt( PvmTraceTid, MYTID );

		if ( cc < 0 )
			sprintf( msg, "setMsg \"Error Spawning %s\"", name );

		else
		{
			sprintf( result, "%d Task%s of %s Spawned%s%s",
				cc, ( cc != 1 ? "s" : "" ), name, tmp,
				( cc > 0 ? ":" : "" ) );
			
			for ( i=0 ; i < cc ; i++ )
			{
				sprintf( tmp, " 0x%x", tids[i] );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE );
			}

			sprintf( msg, "setMsg \"%s\"", result );
		}

		free( tids );

		free( init );

		free( name );

		Tcl_Eval( interp, msg );
	}

	else if ( !strcmp( argv[1], "kill" ) )
	{
		sscanf( argv[2], "%x", &tid );

		name = copy_str( argv[3] );

		if ( !tid )
		{
			if ( !pvm_tasks( 0, &ntask, &tip ) && ntask > 0 )
			{
				tids = (int *) malloc( (unsigned) ntask * sizeof(int) );
				memcheck( tids, "pvm_tasks() TIDs Array" );

				for ( i=0 ; i < ntask ; i++ )
				{
					tids[i] = tip[i].ti_tid;

					if ( tids[i] != MYTID )
					{
						pvm_kill( tids[i] );

						if ( GROUPTASK( tip[i].ti_a_out ) )
							reset_groups();
					}
				}

				sprintf( tmp, "setMsg \"All Tasks Killed.\"" );

				for ( i=0 ; i < ntask ; i++ )
				{
					if ( tids[i] != MYTID )
						wait_kill( tids[i] );
				}

				free( tids );
			}
		}

		else
		{
			cc = pvm_kill( tid );

			if ( !cc )
			{
				sprintf( tmp, "setMsg \"Task t%x Killed.\"", tid );

				if ( GROUPTASK( name ) )
					reset_groups();

				wait_kill( tid );
			}

			else
			{
				sprintf( tmp,
					"setMsg \"Error Killing Task t%x\"", tid );
			}
		}

		free( name );

		Tcl_Eval( itp, tmp );
	}

	else if ( !strcmp( argv[1], "signal" ) )
	{
		sscanf( argv[2], "%x", &tid );

		signal = signal_by_name( argv[3] );

		if ( !tid )
		{
			if ( !pvm_tasks( 0, &ntask, &tip ) )
			{
				for ( i=0 ; i < ntask ; i++ )
				{
					T = &(tip[i]);

					if ( T->ti_tid != MYTID )
						pvm_sendsig( T->ti_tid, signal );
				}

				sprintf( tmp, "setMsg \"All Tasks Signaled.\"" );
			}
		}

		else
		{
			cc = pvm_sendsig( tid, signal );

			if ( !cc )
			{
				sprintf( tmp, "setMsg \"Task t%x Signaled %s (%d)\"",
					tid, argv[3], signal );
			}

			else
			{
				sprintf( tmp,
					"setMsg \"Error Signaling Task t%x %s (%d)\"",
					tid, argv[3], signal );
			}
		}

		Tcl_Eval( itp, tmp );
	}

	else if ( !strcmp( argv[1], "systasks" ) )
	{
		if ( !strcmp( argv[3], "ON" ) )
			stval = TRUE;
		
		else
			stval = FALSE;

		if ( !strcmp( argv[2], "group" ) )
			TRACE_GROUP_TASKS = stval;
	}

	return( TCL_OK );
}

/* ARGSUSED */
int get_tasks_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	HOST H;

	struct pvmtaskinfo *T;
	struct pvmtaskinfo *tip;

	char tmp[1024];

	char *a_out;
	char *type;

	int found;
	int ntask;
	int i;

	if ( argc < 2 )
	{
		Tcl_SetResult( itp,
			"usage: get_tasks_proc <type>", TCL_STATIC );

		return( TCL_ERROR );
	}

	type = copy_str( argv[1] );

	if ( !pvm_tasks( 0, &ntask, &tip ) )
	{
		for ( i=0 ; i < ntask ; i++ )
		{
			T = &(tip[i]);

			if ( T->ti_tid != MYTID )
			{
				H = HOST_LIST;

				found = 0;

				while ( H != NULL && !found )
				{
					if ( H->pvmd_tid == T->ti_host )
						found++;

					else
						H = H->next;
				}

				if ( strcmp( T->ti_a_out, "" ) )
					a_out = T->ti_a_out;
				
				else
					a_out = "-";

				if ( found )
				{
					sprintf( tmp, "add_list_task %s %s %s %x",
						type, H->alias, a_out, T->ti_tid );
				}

				else
				{
					sprintf( tmp, "add_list_task %s ??? %s %x",
						type, a_out, T->ti_tid );
				}

				Tcl_Eval( itp, tmp );
			}
		}
	}

	return( TCL_OK );
}

wait_kill( tid )
int tid;
{
	struct pvmtaskinfo *T;
	struct pvmtaskinfo *tip;

	int found;
	int ntask;
	int cnt;
	int i;

	cnt = 0;

	do
	{
		found = 0;

		if ( !pvm_tasks( 0, &ntask, &tip ) )
		{
			for ( i=0 ; i < ntask && !found ; i++ )
			{
				T = &(tip[i]);

				if ( T->ti_tid == tid )
				{
					found++;

					if ( !strcmp( T->ti_a_out, "" ) )
						cnt++;
				}
			}
		}
	}
	while ( found && cnt < 10 );
}

/* ARGSUSED */
int reset_pvm_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	struct pvmtaskinfo *tip;

	int ntask;
	int inum;
	int tid;
	int i;

	Tcl_Eval( itp, "setMsg \"Resetting PVM...\"" );

	/* Copied from console code - cons.c */

	if ( !pvm_tasks( 0, &ntask, &tip ) )
	{
		for ( i=0 ; i < ntask ; i++ )
		{
			tid = tip[i].ti_tid;

			if ( tid != 0 && tid != MYTID )
				pvm_kill( tid );
		}
	}

	reset_groups();

	/* Re-add XPVM to "xpvm" group */

	inum = pvm_joingroup( "xpvm" );

	if ( inum != 0 )
	{
		printf( "\nWarning: XPVM Group Already Present, inum=%d\n\n",
			inum );
	}

	GROUPS_ALIVE = TRUE;

	/* Done */

	Tcl_Eval( itp, "setMsg \"PVM Reset Done.\"" );

	return( TCL_OK );
}

reset_groups()
{
	int i, j;

	while ( (i = pvm_lookup( "pvmgs", -1, &j )) >= 0 )
		pvm_delete( "pvmgs", i );

	gstid = -1;    /* Hack to force re-start of group servers... */

	GROUPS_ALIVE = FALSE;
}

/* ARGSUSED */
int reset_views_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	int ret;

	ret = do_reset_views( itp );

	return( ret );
}

do_reset_views( itp )
Tcl_Interp *itp;
{
	TASK Tnext;
	TASK T;

	MSG Mnext;
	MSG M;

	int ret;

	Tcl_Eval( itp, "setMsg \"Resetting XPVM Views...\"" );

	/* Reset Time Vars */

	CURRENT_TIME.tv_sec = -1;
	CURRENT_TIME.tv_usec = -1;

	BASE_TIME.tv_sec = -1;
	BASE_TIME.tv_usec = -1;

	/* Reset Task List */

	T = TASK_LIST;

	while ( T != NULL )
	{
		Tnext = T->next;

		free_task( &T );

		T = Tnext;
	}

	TASK_LIST = (TASK) NULL;

	/* Reset Message List */

	M = MSG_LIST;

	while ( M != NULL )
	{
		Mnext = M->next;

		free_msg( &M );

		M = Mnext;
	}

	MSG_LIST = (MSG) NULL;

	/* Reset Interface */

	ret = Tcl_Eval( itp, "reset_interface" );

	Tcl_Eval( itp, "setMsg \"XPVM Views Reset Done.\"" );

	return( ret );
}

/* ARGSUSED */
int reset_trace_file_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	setup_trace( itp );

	return( TCL_OK );
}

/* ARGSUSED */
int quit_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	int cc;

	if ( MYTID > 0 )
	{
		if ( GROUPS_ALIVE )
		{
			cc = pvm_getinst( "xpvm", MYTID );

			if ( cc >= 0 )
			{
				cc = pvm_lvgroup( "xpvm" );

				if ( cc < 0 )
				{
					printf( "\nError Leaving XPVM Group, cc=%d\n\n",
						cc );
				}
			}
		}

		printf( "Quitting xpvm - pvmd still running.\n" );

		pvm_exit();
	}

	exit( 0 );
}

/* ARGSUSED */
int halt_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	pvm_halt();

	exit( 0 );
}

/* ARGSUSED */
int playback_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	char *strcat();

	char tmp[255];

	int index;

	index = (int) clientData;

	TRACE_STATUS = index;

	set_trace_controls();

	switch ( index )
	{
		case TRACE_REWIND:
		{
			if ( TRACE_FILE_STATUS == TRACE_FILE_OVERWRITE )
			{
				TRACE_FILE_STATUS = TRACE_FILE_PLAYBACK;

				PROCESS_COUNTER_INTERVAL = PROCESS_COUNTER_PLAYBACK;
				RECV_TIMER_INTERVAL = RECV_TIMER_PLAYBACK;

				strcpy( tmp, "global trace_file_status; " );
				
				strcat( tmp, "set trace_file_status \"PlayBack\"" );

				Tcl_Eval( interp, tmp );
			}

			if ( TRACE_IN != NULL )
				fclose( TRACE_IN );

			TRACE_OUT = (FILE *) NULL;

			TRACE_IN = fopen( TRACE_FILE, "r" );
			filecheck( TRACE_IN, TRACE_FILE );

			clear_hosts_for_playback();

			TRACE_STATUS = TRACE_STOP;

			set_trace_controls();

			TRACE_PENDING = 0;

			if ( do_reset_views( itp ) == TCL_ERROR )
				return( TCL_ERROR );

			break;
		}

		case TRACE_STOP:
		{
			break;
		}

		case TRACE_FWD:
		case TRACE_FWDSTEP:
		{
			TRACE_ACTIVE = TRUE;

			break;
		}
	}

	return( TCL_OK );
}

/* ARGSUSED */
int trace_file_status_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	if ( argc != 2 )
	{
		Tcl_SetResult( itp,
			"arg count - usage: trace_file_status_handle <status>",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	if ( !strcmp( argv[1], "OverWrite" ) )
	{
		TRACE_FILE_STATUS = TRACE_FILE_OVERWRITE;

		PROCESS_COUNTER_INTERVAL = PROCESS_COUNTER_OVERWRITE;
		RECV_TIMER_INTERVAL = RECV_TIMER_OVERWRITE;
	}

	else if ( !strcmp( argv[1], "PlayBack" ) )
	{
		TRACE_FILE_STATUS = TRACE_FILE_PLAYBACK;

		PROCESS_COUNTER_INTERVAL = PROCESS_COUNTER_PLAYBACK;
		RECV_TIMER_INTERVAL = RECV_TIMER_PLAYBACK;
	}

	if ( do_reset_views( itp ) == TCL_ERROR )
		return( TCL_ERROR );

	setup_trace( itp );

	return( TCL_OK );
}

/* ARGSUSED */
int trace_file_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	if ( argc != 2 )
	{
		Tcl_SetResult( itp,
			"arg count - usage: trace_file_handle <file_name>",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	if ( strcmp( argv[1], TRACE_FILE ) )
	{
		strcpy( TRACE_FILE, argv[1] );

		TRACE_OVERWRITE_FLAG = FALSE;

		if ( do_reset_views( itp ) == TCL_ERROR )
			return( TCL_ERROR );

		setup_trace( itp );
	}

	return( TCL_OK );
}

setup_trace( itp )
Tcl_Interp *itp;
{
	int ecnt;
	int fck;
	int ret;
	int i;

	ret = TRUE;

	if ( TRACE_OUT != NULL )
	{
		fclose( TRACE_OUT );

		TRACE_OUT = (FILE *) NULL;
	}

	if ( TRACE_IN != NULL )
	{
		fclose( TRACE_IN );

		TRACE_IN = (FILE *) NULL;
	}

	TRACE_PENDING = 0;

	if ( strcmp( TRACE_FILE, "" ) )
	{
		switch ( TRACE_FILE_STATUS )
		{
			case TRACE_FILE_OVERWRITE:
			{
				if ( check_overwrite_exists( itp ) )
				{
					TRACE_OUT = fopen( TRACE_FILE, "w" );
					fck = filecheck( TRACE_OUT, TRACE_FILE );
	
					if ( fck )
					{
						TRACE_IN = fopen( TRACE_FILE, "r" );
						filecheck( TRACE_IN, TRACE_FILE );
					}
	
					dump_trace_header();

					restore_hosts_from_playback();

					for ( i=0 ; i < TRACE_MAX ; i++ )
						TEV_TRACE[i] = 0;

					gettimeofday( &TRACE_TIME,
						(struct timezone *) NULL );

					ecnt = save_host_status_events();

					TRACE_STATUS = TRACE_FWD;

					set_trace_controls();

					TRACE_PENDING = ecnt;
				}

				else
					ret = FALSE;

				break;
			}

			case TRACE_FILE_PLAYBACK:
			{
				TRACE_OUT = (FILE *) NULL;

				TRACE_IN = fopen( TRACE_FILE, "r" );
				filecheck( TRACE_IN, TRACE_FILE );
	
				clear_hosts_for_playback();

				TRACE_STATUS = TRACE_STOP;

				set_trace_controls();

				TRACE_PENDING = 0;

				break;
			}
		}
	}

	return( ret );
}

/* ARGSUSED */
int define_trace_mask_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	TRACE_MASK_INDEX TMI;

	char *TM;

	char result[2048];
	char tmp[4096];

	char *maskstr;
	char *liststr;

	char **av;
	int ac;

	int setall;
	int found;
	int nope;
	int i, j;

	if ( argc < 3 )
	{
		Tcl_SetResult( itp,
			"usage: define_trace_mask <mask_name> <event_list>",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	maskstr = copy_str( argv[1] );

	if ( !strcmp( maskstr, "DEFAULT" ) )
	{
		TM = TRACE_MASK;

		setall = TRUE;
	}

	else
	{
		found = FALSE;

		for ( i=0 ; i < GROUP_MASK_MAX && !found ; i++ )
		{
			if ( !strcmp( maskstr, GROUP_MASK_STRS[i] ) )
			{
				TM = GROUP_MASKS[i];

				found++;
			}
		}

		if ( !found )
			printf( "Error: Unknown Mask Group \"%s\"\n", maskstr );

		setall = FALSE;
	}

	TEV_INIT_MASK( TM );

	liststr = copy_str( argv[2] );

	Tcl_SplitList( itp, liststr, &ac, &av );

	for ( i=0 ; i < ac ; i++ )
	{
		LOOKUP_TRACE_MASK_NAME( av[i], TMI );

		if ( TMI != NULL )
			TEV_SET_MASK( TM, TMI->index );

		else
			printf( "Error: Trace Mask For \"%s\" Not Found\n", av[i] );
	}

	if ( setall )
	{
		pvm_settmask( PvmTaskChild, TRACE_MASK );

		TMI = TM_INDEX_LIST;

		strcpy( result, "" );

		/* Set Regular Event Buttons */

		while ( TMI != NULL )
		{
			if ( TEV_CHECK_MASK( TRACE_MASK, TMI->index ) )
				sprintf( tmp, "{ %s ON } ", TMI->name );

			else
				sprintf( tmp, "{ %s OFF } ", TMI->name );

			append_cmd_str( result, tmp, 2048, "trace_mask_result",
				TRUE );

			TMI = TMI->next;
		}

		/* Check Group Event Buttons */

		for ( i=0 ; i < GROUP_MASK_MAX ; i++ )
		{
			TM = GROUP_MASKS[i];

			nope = FALSE;

			for ( j=TEV_FIRST ; j <= TEV_MAX && !nope ; j += 2 )
			{
				if ( TEV_CHECK_MASK( TM, j )
					&& !TEV_CHECK_MASK( TRACE_MASK, j ) )
				{
					nope = TRUE;
				}
			}

			if ( nope )
				sprintf( tmp, "{ %s OFF } ", GROUP_MASK_STRS[i] );

			else
				sprintf( tmp, "{ %s ON } ", GROUP_MASK_STRS[i] );

			append_cmd_str( result, tmp, 2048, "trace_mask_result",
				TRUE );
		}

		sprintf( tmp, "trace_mask_result { %s }", result );

		Tcl_Eval( itp, tmp );
	}

	free( maskstr );

	free( liststr );

	return( TCL_OK );
}

/* ARGSUSED */
int trace_mask_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	TRACE_MASK_INDEX TMI;

	char *TM;

	char result[2048];
	char tmp[4096];

	char *onoffstr;
	char *evstr;

	int found;
	int index;
	int onoff;
	int nope;
	int i, j;
	int set;

	if ( argc < 3 )
	{
		Tcl_SetResult( itp,
			"usage: pvm_trace_mask <event> [ ON | OFF ]",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	evstr = copy_str( argv[1] );

	onoffstr = copy_str( argv[2] );

	if ( !strcmp( onoffstr, "ON" ) )
		onoff = TRUE;
	
	else
		onoff = FALSE;

	set = FALSE;

	LOOKUP_TRACE_MASK_NAME( evstr, TMI );

	if ( TMI != NULL )
	{
		index = TMI->index;

		if ( onoff )
			TEV_SET_MASK( TRACE_MASK, index );
		
		else
			TEV_UNSET_MASK( TRACE_MASK, index );

		pvm_settmask( PvmTaskChild, TRACE_MASK );

		set = TRUE;
	}

	else
	{
		found = 0;

		for ( i=0 ; i < GROUP_MASK_MAX && !found ; i++ )
		{
			if ( !strcmp( evstr, GROUP_MASK_STRS[i] ) )
			{
				TM = GROUP_MASKS[i];

				found++;
			}
		}

		if ( found )
		{
			strcpy( result, "" );

			for ( i=TEV_FIRST ; i <= TEV_MAX ; i += 2 )
			{
				if ( TEV_CHECK_MASK( TM, i ) )
				{
					LOOKUP_TRACE_MASK_INDEX( i, TMI );

					if ( onoff )
					{
						TEV_SET_MASK( TRACE_MASK, i );

						sprintf( tmp, "{ %s ON } ", TMI->name );
					}
					
					else
					{
						TEV_UNSET_MASK( TRACE_MASK, i );

						sprintf( tmp, "{ %s OFF } ", TMI->name );
					}

					append_cmd_str( result, tmp, 2048,
						"trace_mask_result", TRUE );
				}
			}

			pvm_settmask( PvmTaskChild, TRACE_MASK );

			sprintf( tmp, "trace_mask_result { %s }", result );

			Tcl_Eval( itp, tmp );

			set = TRUE;
		}

		else
			printf( "Trace Event %s Not Found In Mask\n", evstr );
	}

	if ( set )
	{
		strcpy( result, "" );

		for ( i=0 ; i < GROUP_MASK_MAX ; i++ )
		{
			TM = GROUP_MASKS[i];

			nope = FALSE;

			for ( j=TEV_FIRST ; j <= TEV_MAX && !nope ; j += 2 )
			{
				if ( TEV_CHECK_MASK( TM, j )
					&& !TEV_CHECK_MASK( TRACE_MASK, j ) )
				{
					nope = TRUE;
				}
			}

			if ( nope )
				sprintf( tmp, "{ %s OFF } ", GROUP_MASK_STRS[i] );

			else
				sprintf( tmp, "{ %s ON } ", GROUP_MASK_STRS[i] );

			append_cmd_str( result, tmp, 2048, "trace_mask_result",
				TRUE );
		}

		sprintf( tmp, "trace_mask_result { %s }", result );

		Tcl_Eval( itp, tmp );
	}

	free( onoffstr );

	free( evstr );

	return( TCL_OK );
}

/* ARGSUSED */
int trace_overwrite_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	char *strcat();

	char tmp[255];

	int ecnt;
	int fck;
	int i;

	if ( argc != 2 )
	{
		Tcl_SetResult( itp,
			"arg count - usage: trace_overwrite_result (TRUE/FALSE)",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	if ( TRACE_OUT != NULL )
	{
		fclose( TRACE_OUT );

		TRACE_OUT = (FILE *) NULL;
	}

	if ( TRACE_IN != NULL )
	{
		fclose( TRACE_IN );

		TRACE_IN = (FILE *) NULL;
	}

	if ( !strcmp( argv[1], "TRUE" ) )
	{
		TRACE_OUT = fopen( TRACE_FILE, "w" );
		fck = filecheck( TRACE_OUT, TRACE_FILE );
	
		if ( fck )
		{
			TRACE_IN = fopen( TRACE_FILE, "r" );
			filecheck( TRACE_IN, TRACE_FILE );
		}

		dump_trace_header();

		restore_hosts_from_playback();

		for ( i=0 ; i < TRACE_MAX ; i++ )
			TEV_TRACE[i] = 0;

		gettimeofday( &TRACE_TIME, (struct timezone *) NULL );

		ecnt = save_host_status_events();

		TRACE_OVERWRITE_FLAG = TRUE;

		TRACE_STATUS = TRACE_FWD;

		set_trace_controls();

		TRACE_PENDING = ecnt;

		if ( TRACE_DO_SPAWN )
			Tcl_Eval( itp, "do_spawn again" );
	}

	else
	{
		TRACE_FILE_STATUS = TRACE_FILE_PLAYBACK;

		PROCESS_COUNTER_INTERVAL = PROCESS_COUNTER_PLAYBACK;
		RECV_TIMER_INTERVAL = RECV_TIMER_PLAYBACK;

		TRACE_IN = fopen( TRACE_FILE, "r" );
		filecheck( TRACE_IN, TRACE_FILE );

		clear_hosts_for_playback();

		strcpy( tmp, "global trace_file_status; " );

		strcat( tmp,
			"set trace_file_status \"PlayBack\"" );

		if ( Tcl_Eval( itp, tmp ) == TCL_ERROR )
			return( TCL_ERROR );

		TRACE_STATUS = TRACE_STOP;

		set_trace_controls();

		TRACE_DO_SPAWN = FALSE;

		TRACE_PENDING = 0;
	}

	return( TCL_OK );
}

/* ARGSUSED */
int output_file_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	if ( argc != 2 )
	{
		Tcl_SetResult( itp,
			"arg count - usage: output_file_handle <file_name>",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	if ( strcmp( argv[1], OUTPUT_FILE ) )
	{
		strcpy( OUTPUT_FILE, argv[1] );

		if ( OUTPUT_FP != NULL )
			fclose( OUTPUT_FP );
		
		if ( strcmp( OUTPUT_FILE, "" ) )
		{
			OUTPUT_FP = fopen( OUTPUT_FILE, "w" );
			filecheck( OUTPUT_FP, OUTPUT_FILE );
		}
	}

	return( TCL_OK );
}

/* ARGSUSED */
int get_hosts_menu_list( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	HOST H;

	ARCH A;

	char **labels;
	char **types;
	char **states;
	char **icons;

	char *list;

	int *indices;

	int num;
	int i;

	/* Generate Lists */

	num = MAX_HID + NHOSTS + 1;

	labels = (char **) malloc( (unsigned) num * sizeof(char *) );
	memcheck( labels, "Hosts Menu Labels" );

	types = (char **) malloc( (unsigned) num * sizeof(char *) );
	memcheck( types, "Hosts Menu Button Types" );

	states = (char **) malloc( (unsigned) num * sizeof(char *) );
	memcheck( states, "Hosts Menu Button States" );

	indices = (int *) malloc( (unsigned) num * sizeof(int) );
	memcheck( indices, "Hosts Menu Button Indices" );

	icons = (char **) malloc( (unsigned) num * sizeof(char *) );
	memcheck( icons, "Hosts Icons" );

	/* Console Commands */

	for ( i=0 ; i < MAX_HID ; i++ )
	{
		labels[ i ] = copy_str( HOST_CMD_STRS[ i ] );

		types[ i ] = copy_str( "command" );

		states[ i ] = copy_str( "OFF" );

		indices[ i ] = i;

		icons[ i ] = get_arch_icon_str( (ARCH) NULL );
	}

	/* Host Names */

	H = HOST_LIST;

	i = 0;

	while ( H != NULL )
	{
		labels[ MAX_HID + i ] = host_name( H, FALSE );

		types[ MAX_HID + i ] = copy_str( "host" );

		if ( H->in_pvm == IN_PVM || H->in_pvm == TO_BE_ADDED )
		{
			states[ MAX_HID + i ] = copy_str( "ON" );

			A = get_arch_code( H->arch );

			if ( A != NULL )
				icons[ MAX_HID + i ] = get_arch_icon_str( A );

			else
				icons[ MAX_HID + i ] = get_arch_icon_str( (ARCH) NULL );
		}

		else
		{
			states[ MAX_HID + i ] = copy_str( "OFF" );

			icons[ MAX_HID + i ] = get_arch_icon_str( (ARCH) NULL );
		}

		indices[ MAX_HID + i ] = MAX_HID + i;

		H = H->next;

		i++;
	}

	/* Other Host Entry */

	labels[ MAX_HID + NHOSTS ] = copy_str( "Other Hosts" );

	types[ MAX_HID + NHOSTS ] = copy_str( "command" );

	states[ MAX_HID + NHOSTS ] = copy_str( "OFF" );

	indices[ MAX_HID + NHOSTS ] = -1;

	icons[ MAX_HID + NHOSTS ] = get_arch_icon_str( (ARCH) NULL );

	/* Assemble List */

	list = assemble_menu_list( num, labels, types, indices,
		states, icons );

	/* Free Temporary Lists */

	for ( i=0 ; i < num ; i++ )
		free( labels[i] );

	free( labels );

	for ( i=0 ; i < num ; i++ )
		free( types[i] );

	free( types );

	for ( i=0 ; i < num ; i++ )
		free( states[i] );

	free( states );

	for ( i=0 ; i < num ; i++ )
		free( icons[i] );

	free( icons );

	free( indices );

	/* Return List as Result */

	Tcl_SetResult( itp, list, TCL_DYNAMIC );

	return( TCL_OK );
}

/* ARGSUSED */
int load_bitmap_file( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	Pixmap bitmap;

	char tmp[1024];

	if ( argc != 2 )
	{
		Tcl_SetResult( itp, "usage: load_bitmap_file <file>",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	sprintf( tmp, "@%s", argv[1] );

	bitmap = Tk_GetBitmap( itp, Top, Tk_GetUid( tmp ) );

	if ( bitmap <= 0 )
	{
		sprintf( tmp, "Error Opening Bitmap %s", argv[1] );

		Tcl_SetResult( itp, copy_str( tmp ), TCL_DYNAMIC );

		return( TCL_ERROR );
	}

	return( TCL_OK );
}

/* ARGSUSED */
int title_info_proc( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	char tmp[255];

	sprintf( tmp, "%s  (PVM %s)  [TID 0x%x]",
		XPVM_VERSION, pvm_version(), MYTID );

	Tcl_SetResult( itp, tmp, TCL_STATIC );

	return( TCL_OK );
}

/* ARGSUSED */
int define_arch( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	ARCH A;

	Pixmap bitmap;

	char tmp[1024];

	int height;
	int width;

	if ( argc != 3 )
	{
		Tcl_SetResult( itp, "usage: define_arch <code> <file>",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	if ( ARCH_LIST == NULL )
	{
		A = ARCH_LIST = create_arch();

		NARCHS = 0;
	}
	
	else
	{
		A = ARCH_LIST;

		while ( A->next != NULL )
			A = A->next;

		A->next = create_arch();

		A = A->next;

		NARCHS++;
	}

	A->code = copy_str( argv[1] );

	sprintf( tmp, "@%s", argv[2] );

	A->name = copy_str( tmp );

	bitmap = Tk_GetBitmap( itp, Top, Tk_GetUid( tmp ) );

	if ( bitmap <= 0 )
	{
		sprintf( tmp, "Error Opening Bitmap %s", argv[2] );

		Tcl_SetResult( itp, copy_str( tmp ), TCL_DYNAMIC );

		return( TCL_ERROR );
	}

	Tk_SizeOfBitmap( Disp, bitmap,
		(unsigned *) &width, (unsigned *) &height );

	A->height = height;
	A->width = width;

	return( TCL_OK );
}

/* ARGSUSED */
int pad_cmd( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	char *result;
	char *ptr;
	char *str;

	int len;
	int nd;
	int nz;
	int i;

	if ( argc < 3 )
	{
		Tcl_SetResult( itp,
			"usage: pad <number_str> <desired_length>",
			TCL_STATIC );

		return( TCL_ERROR );
	}

	str = argv[1];

	len = atoi( argv[2] );

	nd = strlen( str );

	nz = len - nd;

	result = (char *) malloc( (unsigned) (len + 1) * sizeof(char) );
	memcheck( result, "Numerical Pad String" );

	ptr = result;

	for ( i=0 ; i < nz ; i++ )
		*ptr++ = '0';

	sprintf( (char *) (result + nz), "%s", str );

	Tcl_SetResult( itp, result, TCL_DYNAMIC );

	return( TCL_OK );
}

/* ARGSUSED */
int strip_label_cmd( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	char tmp[1024];

	char *result;
	char *ptr;
	char *str;

	int len;

	if ( argc != 2 )
	{
		Tcl_SetResult( itp, "usage: strip_label <str>", TCL_STATIC );

		return( TCL_ERROR );
	}

	str = argv[1];

	ptr = tmp;

	while ( *str != '\0' )
	{
		if ( *str == '-' || *str == ' ' )
			*ptr++ = '_';

		else
			*ptr++ = *str;

		str++;
	}

	*ptr = '\0';

	result = copy_str( tmp );

	Tcl_SetResult( itp, result, TCL_DYNAMIC );

	return( TCL_OK );
}

/* ARGSUSED */
int fix_help_line_cmd( clientData, itp, argc, argv )
ClientData clientData;
Tcl_Interp *itp;
int argc;
char **argv;
{
	char tmp[1024];

	char *result;
	char *ptr;
	char *str;

	int len;

	if ( argc != 2 )
	{
		Tcl_SetResult( itp, "usage: fix_help_line <line>", TCL_STATIC );

		return( TCL_ERROR );
	}

	str = argv[1];

	ptr = tmp;

	while ( *str != '\0' )
	{
		if ( *str == '' )
			*ptr++ = '{';

		else if ( *str == '' )
			*ptr++ = '}';

		else
			*ptr++ = *str;

		str++;
	}

	*ptr = '\0';

	result = copy_str( tmp );

	Tcl_SetResult( itp, result, TCL_DYNAMIC );

	return( TCL_OK );
}

